define({"0":{y:0,u:"../Content/P4API/about.html",l:-1,t:"How to use this guide | P4API",i:0.000802247217644105,a:"How to use this guide This section provides  navigation tips and  information on typographical conventions, feedback options, and additional documentation. Navigation Use following controls to navigate the content in this manual: The arrow buttons   and   at the top of any page bring you to the next ..."},"1":{y:0,u:"../Content/P4API/chapter.overview.html",l:-1,t:"Overview",i:0.000802247217644105,a:"This section provides information on release compatibility, purpose, and architecture of the API. Release compatibility of the API The\n      Helix C/C++ API\n      is subject to change from release to release, and is not guaranteed to be\n      source-code compatible from one release to the next. ..."},"2":{y:0,u:"../Content/P4API/client.programming.compiling.html",l:-1,t:"Compiling and linking Helix Server applications",i:0.000802247217644105,a:"The following sections tell you how to build your application on the\n      target platform. To build p4api.cc, include clientapi.h, which\n      includes all the necessary header files for the sample client\n      application. Additional script libraries for Helix Core extensions To learn about this ..."},"3":{y:0,u:"../Content/P4API/chapter.client.programming.html",l:-1,t:"Application Programming",i:0.000802247217644105,a:"Application Programming If using the P4API in an application which is NOT a console app, see the  Signaler methods  topic for information about changing default memory management and exit() behavior."},"4":{y:0,u:"../Content/P4API/chapter.clientprogramming.jam.html",l:-1,t:"Building with Jam",i:0.00148416667198065,a:"Jam is a build tool, similar in its role to the more familiar\n       make. Jamfiles are to  jam as\n      makefiles are to  make. Jam is an Open Source project sponsored by\n      Perforce Software, Inc.. Jam\n      documentation, source code, and links to precompiled binaries are\n      available from ..."},"5":{y:0,u:"../Content/P4API/client.programming.commands.html",l:-1,t:"Sending commands to the versioning service",i:0.000802247217644105,a:"Helix Server\n      applications interact with the versioning service by: Initializing a connection. Sending commands. Closing the connection. The Helix Server does not maintain any kind of session identifier. The server\n      identifies the sender of commands by its combination of\n      Helix ..."},"6":{y:0,u:"../Content/P4API/client.programming.commands.settings.html",l:-1,t:"Helix Server settings on the user’s machine",i:0.000802247217644105,a:"To determine which server and depot are accessed and how files are\n      mapped, the standard classes in the API observe the\n      Helix Server\n      settings on the user’s machine. Assuming the workstation is configured\n      correctly, your application does not need to provide logic that ..."},"7":{y:0,u:"../Content/P4API/client.programming.commands.connecting.html",l:-1,t:"Connecting to the server",i:0.000802247217644105,a:"To connect to the Helix Server for which the client computer is configured, your client\n      application must call the  client.Init()  method; for\n      example: \nclient.Init( \u0026e );\nif ( e.Test() )\n   {\n      printf(\"Failed to connect:\\n\" );\n      ErrorLog::Abort(); // Displays the error and exits\n ..."},"8":{y:0,u:"../Content/P4API/client.programming.commands.forms.html",l:-1,t:"Displaying Helix Server forms",i:0.000802247217644105,a:"Helix Server\n      client commands that collect a large amount of input from the user (such\n      as  p4 branch,  p4 change,\n       p4 label) use ASCII forms. To interact with your end\n      user, your client application program can display\n      Helix Server\n      ASCII forms such as changelists, ..."},"9":{y:0,u:"../Content/P4API/client.programming.commands.sending.html",l:-1,t:"Sending commands",i:0.000802247217644105,a:"The following example illustrates how you set up arguments and execute\n      the  p4 fstat command on a file named\n       Jam.html. \nchar file[] = \"Jam.html\";\nchar *filep = \u0026file[0];\nclient.SetArgv( 1, \u0026filep );\nclient.Run( \"fstat\", \u0026ui ); For commands with more arguments, use an approach like the\n  ..."},"10":{y:0,u:"../Content/P4API/client.programming.commands.data.html",l:-1,t:"Processing data from the server",i:0.00102955370242295,a:"Helix Server can return tagged data (name-value\n      pairs) for some commands. The following sections tell you how to handle\n      tagged and untagged data. Tagged data The following example shows data returned in tagged format by\n       p4 -Ztag clients command. (The -Z flag specifies that\n      ..."},"11":{y:0,u:"../Content/P4API/client.programming.commands.disconnect.html",l:-1,t:"Disconnecting from the server",i:0.000802247217644105,a:"Disconnecting from the server After your application has finished interacting with the Helix Server, it must disconnect as illustrated below: \nclient.Final( \u0026e );\ne.Abort(); To ensure the application can exit successfully, make sure to call  ClientApi::Final()  before\n      calling the destructor."},"12":{y:0,u:"../Content/P4API/client.programming.fileio.html",l:-1,t:"Performing file I/O",i:0.000802247217644105,a:"The default client file I/O implementation returns a\n      FileSys object, which is described in\n      filesys.h. To intercept client workspace file I/O, replace\n      the FileSys *ClientUser::File()  method\n      by subclassing ClientUser. The following example illustrates how you can override\n     ..."},"13":{y:0,u:"../Content/P4API/client.programming.errors.html",l:-1,t:"Handling errors",i:0.000802247217644105,a:"To encapsulate error handling in a maintainable way, subclass\n      ClientUser at least once for every command you want to run\n      and handle errors in the  HandleError() \n      method of the derived class. To best handle the formatting of error text, parse the error text,\n      looking for ..."},"14":{y:0,u:"../Content/P4API/client.programming.class.html",l:-1,t:"Class overviews",i:0.00344082347447084,a:"Class overviews The following classes comprise the\n      Helix C/C++ API.\n      Public methods for these classes are documented in\n       Public Methods Reference ."},"15":{y:0,u:"../Content/P4API/chapter.clientprogramming.clientapi.html",l:-1,t:"ClientApi - Helix Server connections and commands",i:0.0525922975038922,a:"The ClientApi class represents a connection with the Helix Server. Member functions in this class are used to establish and terminate the\n      connection with the server, establish the settings and protocols to use\n      while running commands, and run\n      Helix Server\n      commands over the ..."},"16":{y:0,u:"../Content/P4API/chapter.clientprogramming.clientprogress.html",l:-1,t:"ClientProgress - progress indicators for Helix Server commands",i:0.00403099825664219,a:"The ClientProgress class introduced in 2012.2 provides a\n      means to report on the progress of running commands; you can customize\n      this behavior by subclassing ClientUser and\n      ClientProgress. In ClientUser, implement  ClientUser::CreateProgress() \n      and  ..."},"17":{y:0,u:"../Content/P4API/chapter.clientprogramming.clientuser.html",l:-1,t:"ClientUser - I/O for Helix Server commands",i:0.0297409414971153,a:"The ClientUser class is used for all client-side input and\n      output. This class implements methods that return output from the server\n      to the user after a command is invoked, and gather input from the user\n      when needed. Member functions in this class are used to format and display ..."},"18":{y:0,u:"../Content/P4API/chapter.clientprogramming.error.html",l:-1,t:"Error - collect and report layered errors",i:0.0148225896266073,a:"Member functions in this class are used to store error messages, along\n      with information about generic type and severity, format error messages\n      into a form suitable for display to an end user, or marshal them into a\n      form suitable for transferring over a network. Error objects are ..."},"19":{y:0,u:"../Content/P4API/chapter.clientprogramming.errorlog.html",l:-1,t:"ErrorLog - output error messages",i:0.00315577020143353,a:"ErrorLog - output error messages The ErrorLog class is used to report layered errors, either\n      by displaying error messages to stderr, or by redirecting\n      them to logfiles. On UNIX systems, error messages can also be directed to\n      the syslog daemon."},"20":{y:0,u:"../Content/P4API/chapter.clientprogramming.filesys.html",l:-1,t:"FileSys - Helix Server file I/O",i:0.00621787807994921,a:"The FileSys class provides a platform-independent set of\n      methods used to create, read and write files to disk. You can intercept the file I/O and implement your own client workspace\n      file access routines by replacing FileSys *ClientUser::File()  in a\n      ClientUser subclass. Replacing ..."},"21":{y:0,u:"../Content/P4API/chapter.clientprogramming.ignore.html",l:-1,t:"Ignore - support for rejecting files",i:0.00493648774157273,a:"Ignore - support for rejecting files The Ignore class has two methods,  Ignore::Reject()  and  Ignore::RejectCheck() .\n      Both methods are used by applications to determine whether files destined\n      to be opened for add will be rejected due to matching an entry in an\n      ignore files."},"22":{y:0,u:"../Content/P4API/chapter.clientprogramming.keepalive.html",l:-1,t:"KeepAlive - support for client-side disconnection",i:0.0021025771169396,a:"KeepAlive - support for client-side disconnection The KeepAlive class has only one method,  KeepAlive::IsAlive() .\n      The method is used by applications to support client-side command\n      termination."},"23":{y:0,u:"../Content/P4API/chapter.clientprogramming.mapapi.html",l:-1,t:"MapApi - logic for view mappings",i:0.0167285738652371,a:"The MapApi class allows a client application to duplicate\n      the logic used by the server when interpreting and combining view\n      mappings such as branch views, client views, and protections. Each MapApi object represents a single mapping that is\n      built by calling  MapApi::Insert()  to ..."},"24":{y:0,u:"../Content/P4API/chapter.clientprogramming.options.html",l:-1,t:"Options - parse and store command line options",i:0.00572419850064855,a:"The Options class encapsulates functions useful for parsing\n      command line flags, and also provides a means of storing flag values. Sample code is provided to illustrate how  Options::GetValue()  and\n       Options::Parse()  work\n      together to parse command line options."},"25":{y:0,u:"../Content/P4API/chapter.clientprogramming.p4libraries.html",l:-1,t:"P4Libraries - static initialization of required libraries",i:0.00252622055097814,a:"Performs static initialization of libraries required to use P4API. If the host application handles some of them itself (such as if it has its own copy of one of the libraries) then the initialization can be skipped by passing a combination of P4LibrariesInits values that are OR\u0027d together.  The  ..."},"26":{y:0,u:"../Content/P4API/chapter.clientprogramming.serverhelperapi.html",l:-1,t:"ServerHelperApi - helper methods for creating personal servers",i:0.0236509694983513,a:"The ServerHelperApi class is used to create personal\n      servers. This class is only necessary when initially creating a local\n      server; once it is created you can use the standard\n      ClientApi and ClientUser classes to operate\n      against the server."},"27":{y:0,u:"../Content/P4API/chapter.clientprogramming.signaler.html",l:-1,t:"Signaler - interrupt handling",i:0.00712850386263762,a:"The Signaler class enables the API programmer to register\n      functions to be called when the client application receives an\n      interrupt signal. The Signaler class maintains a list of\n      registered functions and calls each one in turn. See  Signaler methods . By default, after all of the ..."},"28":{y:0,u:"../Content/P4API/chapter.clientprogramming.strbuf.html",l:-1,t:"StrBuf - string manipulation",i:0.0270409852430135,a:"The StrBuf class is the preferred general string\n      manipulation class. This class manages the memory associated with a\n      string, including allocating new memory or freeing old memory as\n      required. The StrBuf class is derived from the StrPtr\n      class, and makes heavy use of the buffer ..."},"29":{y:0,u:"../Content/P4API/chapter.clientprogramming.strdict.html",l:-1,t:"StrDict - field/value manipulation",i:0.0120449196281975,a:"The StrDict class provides a dictionary object of\n      StrPtr s with a simple Get/Put interface. This class\n      contains abstract methods and therefore cannot be instantiated, but its\n      subclasses adhere to the basic interface documented here. ClientApi is a descendant of StrDict; most\n      ..."},"30":{y:0,u:"../Content/P4API/chapter.clientprogramming.strnum.html",l:-1,t:"StrNum - small numeric strings",i:0.0020771487052566,a:"The StrNum class, derived from StrPtr, is\n      designed to hold a small string representing a number. Like a\n      StrBuf, it handles its own memory. Unlike a\n      StrBuf, it does not dynamically resize itself, and is\n      limited to 24 characters, meaning that the largest number that can be\n     ..."},"31":{y:0,u:"../Content/P4API/chapter.clientprogramming.strops.html",l:-1,t:"StrOps - string operations",i:0.0089226074362292,a:"StrOps - string operations StrOps is a memberless class containing static methods for\n      performing operations on strings."},"32":{y:0,u:"../Content/P4API/chapter.clientprogramming.strptr.html",l:-1,t:"StrPtr - text operations",i:0.0108657956328908,a:"The StrPtr class is a very basic pointer/length pair used\n      to represent text. This class provides a number of methods for comparison and reporting,\n      but it is not in itself very useful for storing data; the\n      StrBuf child class is a more practical means of storing\n      data, as it ..."},"33":{y:0,u:"../Content/P4API/chapter.clientprogramming.strref.html",l:-1,t:"StrRef - refer to existing strings",i:0.00862258082558448,a:"The StrRef class is a simple pointer/length pair\n      representing a string. The StrRef class is is derived from\n      StrPtr and does not add a great deal of new functionality to\n      that class, with the exception of methods that make the pointer mutable\n      (and therefore usable), whereas a ..."},"34":{y:0,u:"../Content/P4API/chapter.clientprogramming.monitems.html",l:-1,t:"MonItems - between real-time counters and storage",i:0.000802247217644105,a:"The MonItems class  is the bridge between the counters and the storage. The MemItems class either maps the contents of an existing memory-mapped file into MonItem objects or maps registered MonItem objects into a new or existing memory-mapped file. If you want to write a utility that accesses the ..."},"35":{y:0,u:"../Content/P4API/chapter.clientprogramming.monitem.html",l:-1,t:"MonItem - base class for performance counters",i:0.00206380776494216,a:"The MonItem class contains the infrastructure for mapping counters between variables in code, their registered MonItem forms, and the memory representation that will be written to, and read from, the memory-mapped file.  Constructors MonItem( const char *name, int flags = 0 ) Constructs a new ..."},"36":{y:0,u:"../Content/P4API/chapter.clientprogramming.moninteger.html",l:-1,t:"MonInteger - store 64-bit integer values",i:0.00148416667198065,a:"MonInteger - store 64-bit integer values The MonInteger subclass of MonItem is used to access 64-bit integer values. For inherited methods, see  MonItem - base class for performance counters ."},"37":{y:0,u:"../Content/P4API/chapter.clientprogramming.monintmax.html",l:-1,t:"MonIntMax - tracks the highest recorded value",i:0.000802247217644105,a:"The MonIntMax class is a subclass of MonInteger. Like MonInteger, MonIntMax stores 64-bit integer values but also tracks the highest recorded value. The MonItem subclass of MonItem is used to access 64-bit integer values. For inherited methods, see  MonInteger - store 64-bit integer values ."},"38":{y:0,u:"../Content/P4API/sample-application.html",l:-1,t:"Sample application",i:0.00252622055097814,a:"The sample application, p4api.cc, is located in the sample directory. You can build the sample application with either Make or Jam. /*\n* p4api.cc - a p4 client API example\n*\n* This file is part of the p4api distribution package.\n*\n* This barebones example simply mimics the regular p4 command line\n* ..."},"39":{y:0,u:"../Content/P4API/chapter.methods.html",l:-1,t:"Public Methods Reference",i:0.00372708086665054,a:"Public Methods Reference This section provides information on the available public methods."},"40":{y:0,u:"../Content/P4API/clientapi.html",l:-1,t:"ClientApi methods",i:0.00114320694481238,a:"ClientApi methods This section lists the available ClientApi methods."},"41":{y:0,u:"../Content/P4API/clientapi.defineclient.html",l:-1,t:"ClientApi::DefineClient( const char *, Error * )",i:0.00101873060553401,a:"Sets  P4CLIENT in the Windows registry and applies\n      the setting immediately. Notes To make the new  P4CLIENT setting apply to the next\n      command executed with  Run() ,  DefineClient()  sets\n      the value in the registry and then calls  SetClient() . Example The following code illustrates ..."},"42":{y:0,u:"../Content/P4API/clientapi.definehost.html",l:-1,t:"ClientApi::DefineHost( const char *, Error * )",i:0.00101873060553401,a:"Sets  P4HOST in the Windows registry and applies the\n      setting immediately. Notes To make the new  P4HOST setting apply to the next\n      command executed with  Run() ,  DefineHost()  sets the\n      value in the registry and then calls  SetHost() . Example The following code illustrates how this ..."},"43":{y:0,u:"../Content/P4API/clientapi.defineignorefile.html",l:-1,t:"ClientApi::DefineIgnoreFile( const char *, Error * )",i:0.00212153845304976,a:"Sets  P4IGNORE in the Windows registry and applies\n      the setting immediately. Notes To make the new  P4IGNORE setting apply to the next\n      command executed with  Run() ,  DefineIgnoreFile() \n      sets the value in the registry and then calls  SetIgnoreFile() . See also ClientApi::GetIgnore() ..."},"44":{y:0,u:"../Content/P4API/clientapi.definepassword.html",l:-1,t:"ClientApi::DefinePassword( const char *, Error * )",i:0.00101873060553401,a:"Sets  P4PASSWD in the Windows registry and applies\n      the setting immediately. Notes To make the new  P4PASSWD setting apply to the next\n      command executed with  Run() ,  DefinePassword() \n      sets the value in the registry and then calls  SetPassword() . DefinePassword() \n      does not ..."},"45":{y:0,u:"../Content/P4API/clientapi.defineport.html",l:-1,t:"ClientApi::DefinePort( const char *, Error * )",i:0.00101873060553401,a:"Sets  P4PORT in the Windows registry and applies the\n      setting immediately. Notes In order to make the new  P4PORT setting apply to the\n      next client connection opened with  Init() ,  DefinePort()  sets the\n      value in the registry and then calls  SetPort() . Example The following code ..."},"46":{y:0,u:"../Content/P4API/clientapi.defineuser.html",l:-1,t:"ClientApi::DefineUser( const char *, Error * )",i:0.00101873060553401,a:"Sets  P4USER in the Windows registry and applies the\n      setting immediately. Notes To make the new  P4USER setting apply to the next\n      command executed with  Run() ,  DefineUser()  sets the\n      value in the registry and then calls  SetUser() . Example The following code illustrates how this ..."},"47":{y:0,u:"../Content/P4API/clientapi.dropped.html",l:-1,t:"ClientApi::Dropped()",i:0.000966565738424186,a:"Check if connection is no longer usable. Notes Dropped()  is usually\n      called after  Run() ; it then\n      checks whether the command completed successfully. If the  Init()  is only followed by\n      one  Run() , as in\n      p4api.cc, calling  Final()  and then checking\n      the Error is ..."},"48":{y:0,u:"../Content/P4API/clientapi.final.html",l:-1,t:"ClientApi::Final( Error * )",i:0.0302659401569408,a:"Close connection and return error count. Notes Call this method after you are finished using the ClientApi\n      object to clean up the connection. Every call to  Init()  must eventually be\n      followed by exactly one call to  Final() . Example The following example is a slight modification of ..."},"49":{y:0,u:"../Content/P4API/clientapi.getclient.html",l:-1,t:"ClientApi::GetClient()",i:0.0040966794434491,a:"Get current client setting. Notes The return value of  GetClient()  is a fixed\n      reference to this ClientApi object’s setting. Assigning the return value to a StrPtr results in a\n      StrPtr containing a Text() value that changes\n      if the ClientApi object’s client setting changes. Assigning ..."},"50":{y:0,u:"../Content/P4API/clientapi.getconfig.html",l:-1,t:"ClientApi::GetConfig()",i:0.00111942131378231,a:"Get current configuration file. Notes See  GetClient()  for\n      more about the StrPtr return value. If the  P4CONFIG has not been set,  GetConfig()  returns\n      “noconfig”. Example The following example demonstrates the usage of  GetConfig() . \nClientApi client;\n\nprintf( \"Current P4CONFIG is ..."},"51":{y:0,u:"../Content/P4API/clientapi.getcwd.html",l:-1,t:"ClientApi::GetCwd()",i:0.000966565738424186,a:"Get current working directory. Notes See  GetClient()  for\n      more about the StrPtr return value. If the working directory has been set by a call to  SetCwd()  or  SetCwdNoReload() ,\n      subsequent calls to  GetCwd()  return that\n      setting regardless of the actual working directory. Example ..."},"52":{y:0,u:"../Content/P4API/clientapi.gethost.html",l:-1,t:"ClientApi::GetHost()",i:0.00180566424448207,a:"Get client hostname. Notes See  GetClient()  for\n      more about the StrPtr return value. In some instances,  GetHost()  is not valid\n      until after the network connection has been established with  Init() .  GetHost()  attempts to\n      pull its value from earlier  SetHost()  calls, then\n      ..."},"53":{y:0,u:"../Content/P4API/clientapi.getignore.html",l:-1,t:"ClientApi::GetIgnore()",i:0.00198515456218245,a:"Notes If P4IGNORE is not set, no paths are ignored. See also ClientApi::DefineIgnoreFile() ClientApi::GetIgnoreFile() ClientApi::SetIgnoreFile() Example This example demonstrates the use of  GetIgnore() . \nif ( client-\u003eGetIgnore()-\u003eReject( *clientPath,\n                                      ..."},"54":{y:0,u:"../Content/P4API/clientapi.getignorefile.html",l:-1,t:"ClientApi::GetIgnoreFile()",i:0.00212153845304976,a:"Get the full path name of the ignore file used for the current\n      connection. Notes See  GetClient()  for\n      more about the StrPtr return value. If the  P4IGNORE is unset,  GetIgnoreFile() \n      returns an uninitialized StrPtr. See also ClientApi::DefineIgnoreFile() ClientApi::GetIgnore() ..."},"55":{y:0,u:"../Content/P4API/clientapi.getos.html",l:-1,t:"ClientApi::GetOs()",i:0.00111942131378231,a:"Get name of client operating system. Notes See  GetClient()  for\n      more about the StrPtr return value. GetOs()  returns one of\n      “UNIX”, “vms”, “NT”, “Mac”, or null. Example The following example demonstrates the usage of  GetOs() . \nClientApi client;\nprintf( \"Client OS is %s\\n\", ..."},"56":{y:0,u:"../Content/P4API/clientapi.getpassword.html",l:-1,t:"ClientApi::GetPassword()",i:0.00101873060553401,a:"Get password setting. Notes See  GetClient()  for\n      more about the StrPtr return value. This method returns the password currently set on the client, which may\n      or may not be the one set on the server for this user. The command\n      \" p4 passwd\" sets  P4PASSWD on the\n      client machine ..."},"57":{y:0,u:"../Content/P4API/clientapi.getport.html",l:-1,t:"ClientApi::GetPort()",i:0.00111942131378231,a:"Get current port setting. Notes See  GetClient()  for\n      more about the StrPtr return value. If the environment variable  P4PORT is unset,  GetPort()  sets the port\n      to the default value of perforce:1666. Example The following example demonstrates the usage of  GetPort() . \nClientApi ..."},"58":{y:0,u:"../Content/P4API/clientapi.getprotocol.html",l:-1,t:"ClientApi::GetProtocol( const char * )",i:0.00101873060553401,a:"Get protocol information for this connection. Notes If the variable is unset, the return value is null. If there is a value,\n      it will be a number in most cases, but in the form of a\n      StrPtr rather than an int. Call  GetProtocol() \n      only after a call to  Run() ,\n      because protocol ..."},"59":{y:0,u:"../Content/P4API/clientapi.gettrans.html",l:-1,t:"ClientApi::GetTrans( )",i:0.000802247217644105,a:"Gets an integer that represents  the charset. Example printf(“charset = %d\\n”, client.GetTrans()); Notes Returns an integer value based on the detected charset: none=0 utf8=1 iso8859-1=2 utf16-nobom=3 shiftjis=4 eucjp=5 winansi=6 winoem=7 macosroman=8 iso8859-15=9 iso8859-5=10 koi8-r=11 cp1251=12 ..."},"60":{y:0,u:"../Content/P4API/clientapi.getuser.html",l:-1,t:"ClientApi::GetUser()",i:0.00111942131378231,a:"Get current user setting. Notes See  GetClient()  for\n      more about the StrPtr return value. Example The following example demonstrates the usage of  GetUser() . \nClientApi client;\nprintf( \"Your username is %s\\n\", client.GetUser().Text() ); Executing the preceding code as testuser produces the\n   ..."},"61":{y:0,u:"../Content/P4API/clientapi.init.html",l:-1,t:"ClientApi::Init( Error * )",i:0.0702505928103516,a:"Establish a connection and prepare to run commands. Notes Init()  must be called to\n      establish a connection before any commands can be sent to the server.\n      Each call to  Init()  must\n      be followed by exactly one call to  Final() . If an error occurs during  Init() , it is most likely ..."},"62":{y:0,u:"../Content/P4API/clientapi.run.html",l:-1,t:"ClientApi::Run( const char *, ClientUser * )",i:0.0423907190015274,a:"Run a\n      Helix Server\n      command and return when it completes. Notes The func argument to  Run()  is the\n      Helix Server\n      command to run, (for instance, info or files).\n      Command arguments are not included and must be set separately with  StrDict::SetArgv() . Initialize the ..."},"63":{y:0,u:"../Content/P4API/clientapi.setbreak.html",l:-1,t:"ClientApi::SetBreak( KeepAlive *breakCallback )",i:0.00329091861349548,a:"Establish a callback that is called every 0.5 seconds during command\n      execution. Notes To establish the callback routine, you must call  SetBreak()  after  ClientApi::Init() . See also KeepAlive::IsAlive() Example The following example implements a custom  IsAlive()  that can be\n      called ..."},"64":{y:0,u:"../Content/P4API/clientapi.setclient.html",l:-1,t:"ClientApi::SetClient( const StrPtr * )",i:0.00271046547820909,a:"Sets the client setting to be used for this connection. Notes SetClient()  does not\n      permanently set the  P4CLIENT value in the environment\n      or registry. The new setting applies only to commands executed by calling\n      this ClientApi object’s  Run()  method. Example The following example ..."},"65":{y:0,u:"../Content/P4API/clientapi.setclient_2.html",l:-1,t:"ClientApi::SetClient( const char * )",i:0.000802247217644105,a:"Sets the client setting to be used for this connection. Notes SetClient()  does not\n      permanently set the  P4CLIENT value in the environment\n      or registry. The new setting applies only to commands executed by calling\n      this ClientApi object’s  Run()  method. Example The following example ..."},"66":{y:0,u:"../Content/P4API/clientapi.setcwd.html",l:-1,t:"ClientApi::SetCwd( const StrPtr * )",i:0.00233189470624124,a:"Sets the working directory to be used for this connection. Notes SetCwd()  does not\n      permanently set a new working directory in the client environment. The\n      new setting applies only to commands executed by calling this\n      ClientApi object’s  Run()  method. Example The following code ..."},"67":{y:0,u:"../Content/P4API/clientapi.setcwd_2.html",l:-1,t:"ClientApi::SetCwd( const char * )",i:0.000802247217644105,a:"Sets the working directory to be used for this connection. Notes SetCwd()  does not\n      permanently set a new working directory in the client environment. The\n      new setting applies only to commands executed by calling this\n      ClientApi object’s  Run()  method. Example The following code ..."},"68":{y:0,u:"../Content/P4API/clientapi.setcwdnoreload.html",l:-1,t:"ClientApi::SetCwdNoReload( const StrPtr * )",i:0.00144387346186321,a:"Sets the working directory to be used for this connection without\n      checking  P4CONFIG. Notes SetCwdNoReload() \n      does not permanently set a new working directory in the client\n      environment. The new setting applies only to commands executed by calling\n      this ClientApi object’s  ..."},"69":{y:0,u:"../Content/P4API/clientapi.setcwdnoreload_2.html",l:-1,t:"ClientApi::SetCwdNoReload( const char * )",i:0.000802247217644105,a:"Sets the working directory to be used for this connection without\n      checking  P4CONFIG. Notes SetCwdNoReload() \n      does not permanently set a new working directory in the client\n      environment. The new setting applies only to commands executed by calling\n      this ClientApi object’s  ..."},"70":{y:0,u:"../Content/P4API/clientapi.sethost.html",l:-1,t:"ClientApi::SetHost( const StrPtr * )",i:0.00216700005393127,a:"Sets the hostname to be used for this connection. Notes SetHost()  does not\n      permanently change the host name of the client or set\n       P4HOST in the environment. The new setting applies\n      only to commands executed by calling this ClientApi object’s\n       Run()  method. Example The ..."},});