define({"294":{y:0,u:"../Content/P4API/strptr.value.html",l:-1,t:"StrPtr::Value()",i:0.00581702152369398,a:"Return the char * containing this StrPtr\u0027s\n      text. Notes StrPtr::Value()  is the\n      deprecated form of  StrPtr::Text() . The two\n      functions are equivalent. Their most typical use is converting a\n      StrPtr to a char * for functions outside of the\n      client API to use. Example ..."},"295":{y:0,u:"../Content/P4API/strptr.xcompare.html",l:-1,t:"StrPtr::XCompare( const StrPtr \u0026 )",i:0.00221318738008055,a:"Case sensitive comparison of two StrPtrs. Notes StrPtr::XCompare()  is a\n      wrapper for strcmp(). Its return value, if nonzero,\n      indicates which of the two strings is \"greater\" in the ASCII sense. See also StrPtr::CCompare() StrPtr::Compare() Example \n#include \u003cstdhdrs.h\u003e\n#include ..."},"296":{y:0,u:"../Content/P4API/strref.html",l:-1,t:"StrRef methods",i:0.000802247217644105,a:"StrRef methods This section lists the available StrRef methods."},"297":{y:0,u:"../Content/P4API/strref.constructor.html",l:-1,t:"StrRef::StrRef() (constructor)",i:0.000802247217644105,a:"StrRef::StrRef() (constructor) Construct a StrRef, and leave it unset. Notes If arguments are provided, the constructor calls  Set()  with them."},"298":{y:0,u:"../Content/P4API/strref.constructor_2.html",l:-1,t:"StrRef::StrRef( const StrPtr \u0026 ) (constructor)",i:0.000802247217644105,a:"Construct a StrRef, referencing an existing string. Notes If arguments are provided, the constructor calls  Set()  with them. Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    StrBuf str1;\n\n    str1.Set( \"abc\" );\n    StrRef sr = StrRef( ..."},"299":{y:0,u:"../Content/P4API/strref.constructor_3.html",l:-1,t:"StrRef::StrRef( const char * ) (constructor)",i:0.000802247217644105,a:"Construct a StrRef, referencing an existing string. Notes If arguments are provided, the constructor calls  Set()  with them. Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    char chars[] = \"abc\";\n    StrRef sr = StrRef( chars );\n\n    ..."},"300":{y:0,u:"../Content/P4API/strref.constructor_4.html",l:-1,t:"StrRef::StrRef( const char * , int ) (constructor)",i:0.000802247217644105,a:"Construct a StrRef, referencing an existing string. Notes If arguments are provided, the constructor calls  Set()  with them. StrRef::Set()  does not copy\n      the target string; it simply creates a pointer to it. Be sure that the\n      StrRef pointing to the target string does not outlive the\n     ..."},"301":{y:0,u:"../Content/P4API/strref.null.html",l:-1,t:"StrRef::Null()",i:0.00284352550291256,a:"Return a null StrPtr. Notes StrRef::Null()  is a static\n      function. Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    StrBuf str1;\n\n    str1.Set( \"abc\" );\n    StrRef sr = StrRef( str1 );\n\n    if ( sr == StrRef::Null() )\n        cout ..."},"302":{y:0,u:"../Content/P4API/strref.operator.html",l:-1,t:"StrRef::operator =( StrPtr \u0026 )",i:0.000802247217644105,a:"Set a StrPtr to reference an existing StrPtr\n      or null-terminated string. Notes The = operator is equivalent to calling  Set() . Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    StrBuf str1;\n\n    str1.Set( \"xyz\" );\n    StrRef sr = ..."},"303":{y:0,u:"../Content/P4API/strref.operator_2.html",l:-1,t:"StrRef::operator =( char * )",i:0.000802247217644105,a:"Set a StrPtr to reference an existing StrPtr\n      or null-terminated string. Notes The = operator is equivalent to calling  Set() . Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    char chars[] = \"xyz\";\n    StrRef sr;\n\n    sr = chars;\n\n ..."},"304":{y:0,u:"../Content/P4API/strref.operator_3.html",l:-1,t:"StrRef::operator +=( int )",i:0.000802247217644105,a:"Increase a StrRef’s pointer and decrease its length. Notes This method has the effect of removing len characters from\n      the beginning of the StrRef. It does not, however, free the\n      memory allocated to those characters. Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include ..."},"305":{y:0,u:"../Content/P4API/strref.set.html",l:-1,t:"StrRef::Set( char * )",i:0.00673206755040365,a:"Set a StrRef to reference an existing null-terminated\n      string. Notes StrRef::Set()  does not copy\n      the target string; it simply establishes a pointer to it. Be sure that\n      the StrRef pointing to the target string does not outlive\n      the target string. Example \n#include ..."},"306":{y:0,u:"../Content/P4API/strref.set_2.html",l:-1,t:"StrRef::Set( char * , int )",i:0.000802247217644105,a:"Set a StrRef to reference an existing null-terminated\n      string. Notes StrRef::Set()  does not copy\n      the target string; it simply establishes a pointer to it. Be sure that\n      the StrRef pointing to the target string does not outlive\n      the target string. Example \n#include ..."},"307":{y:0,u:"../Content/P4API/strref.set_3.html",l:-1,t:"StrRef::Set( const StrPtr * )",i:0.000802247217644105,a:"Set a StrRef to reference an existing\n      StrPtr. Notes StrRef::Set()  does not copy\n      the target string; it simply establishes a pointer to it. Be sure that\n      the StrRef pointing to the target string does not outlive\n      the target string. Example \n#include \u003ciostream\u003e\n\n#include ..."},"308":{y:0,u:"../Content/P4API/strref.set_4.html",l:-1,t:"StrRef::Set( const StrPtr \u0026 )",i:0.000802247217644105,a:"Set a StrRef to reference an existing\n      StrPtr. Notes StrRef::Set()  does not copy\n      the target string; it simply establishes a pointer to it. Be sure that\n      the StrRef pointing to the target string does not outlive\n      the target string. Example \n#include \u003ciostream\u003e\n\n#include ..."},"309":{y:0,u:"../Content/Shared/glossary.html",l:-1,t:"Glossary",i:0.000802247217644105,a:"Glossary"},"310":{y:0,u:"../Content/P4API/license.statements.html",l:-1,t:"License statements",i:0.000802247217644105,a:"To get a listing of the third-party software licenses that Helix Core Server uses, at the command line, type the p4 help legal command. To get a listing of the third-party software licenses that the local client (such as P4V) uses, at the command line, type the p4 help -l legal command."},});